// C Source File
// Created 09.01.2004; 16:00:46

#include <tigcclib.h>
//#include <extgraph.h>

//****************************************************************************

#define MAX_X 160
#define MAX_Y 100

#define PI2 (6.283185307) 
#define PIH (1.570796327) 

#define PI_K 314 
#define PI2_K 628
#define PIH_K 157
#define PI12_K 26

#define MAP_SIZE 250

const unsigned char bit_table[8]={0x80,0x40,0x20,0x10,0x8,0x4,0x2,0x1};

//****************************************************************************

struct point3d_i_type
{
	short x, y, z;
};

//****************************************************************************

unsigned short i, j, k, pos, x, y, z, xo, yo, zo;
long					 l, w;
short					 is, js, ks, ls, iterations, temp_s, MAX_X2, MAX_Y2;
short					 details, horizon, width, map_buf, map_buf_fin;
short 				 xs, ys, zs, xso, xsoo, yso, xn, yn, zn, xr, yr, zr;
unsigned short ch;
unsigned char  b, txt[40], interlace, render_mode, method;
unsigned char  *map_data_p;
SCR_RECT			 full_screen = {{0, 0, 159, 99}};

struct point3d_i_type ray_map[(160*67)+1];
struct point3d_i_type movement;
struct point3d_i_type cam;

//****************************************************************************

#include "pixel.h"

//****************************************************************************
//****************************************************************************
//****************************************************************************

#define ASM_SWAP(val) ({\
    register unsigned long tmp = val;\
    asm volatile ("swap %0" : "=d" (tmp) : "0" (tmp));\
    tmp;})

/*===========================================================================*/
/* draws a horizontal line from (x1,y) to (x2,y) in given plane              */
/*                                                                           */
/* valid modes: A_REPLACE,A_NORMAL,A_REVERSE,A_XOR                           */
/*===========================================================================*/
void FastDrawHLine(unsigned char* plane,short x1,short x2,short y,short mode) {
    static const unsigned short table1[16] = {0xffff,0x7fff,0x3fff,0x1fff,
                                              0x0fff,0x07ff,0x03ff,0x01ff,
                                              0x00ff,0x007f,0x003f,0x001f,
                                              0x000f,0x0007,0x0003,0x0001};
    static const unsigned short table2[16] = {0x0000,0x8000,0xc000,0xe000,
                                              0xf000,0xf800,0xfc00,0xfe00,
                                              0xff00,0xff80,0xffc0,0xffe0,
                                              0xfff0,0xfff8,0xfffc,0xfffe};
    short           dx;
    short           sx;
    unsigned short* p;

    if (x1>x2) {
        short tmp = x1;
        x1 = x2;
        x2 = tmp;
    }

    p  = (unsigned short*)(plane+(y<<5)-(y<<1)+((x1>>3)&0x1e));
    dx = x2-x1+1;
    sx = x1 & 0x000f;

    if (dx<16) {
        unsigned long val = (ASM_SWAP(table2[dx])) >> sx;
        if (mode == A_REPLACE || mode == A_NORMAL) {
            *(unsigned long*)p |= val;
        }
        else if (mode == A_REVERSE) {
            *(unsigned long*)p &= ~val;
        }
        else if (mode == A_XOR) {
            *(unsigned long*)p ^= val;
        }
        return;
    }

    if (mode == A_REPLACE || mode == A_NORMAL) {
        if (sx) {
            *p++ |= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ |= 0xffff;
            dx-=16;
        }
        if (dx) *p |= table2[dx];
    }
    else if (mode == A_REVERSE) {
        if (sx) {
            *p++ &= ~(table1[sx]);
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ &= 0x0;
            dx-=16;
        }
        if (dx) *p &= ~(table2[dx]);
    }
    else if (mode == A_XOR) {
        if (sx) {
            *p++ ^= table1[sx];
            dx -= (16-sx);
        }
        while (dx >= 16) {
            *p++ ^= 0xffff;
            dx-=16;
        }
        if (dx) *p ^= table2[dx];
    }
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void clrscr_gr (short delay)
{
	long l;
 	if (delay > 0) for (l=0; l<100000; l++);
 	GraySetAMSPlane (LIGHT_PLANE); ClrScr ();
 	if (delay > 0) for (l=0; l<100000; l++);
  GraySetAMSPlane (DARK_PLANE); ClrScr ();
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void print_title (short x, short y)
{
	GraySetAMSPlane (LIGHT_PLANE); DrawStr(x+0, y+1, txt, A_NORMAL);
																 DrawStr(x+1, y+0, txt, A_NORMAL);
	GraySetAMSPlane (DARK_PLANE);  DrawStr(x+1, y+0, txt, A_NORMAL);
																 DrawStr(x+2, y+0, txt, A_NORMAL);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void check_keys (void)
{
		if (kbhit())
		{
			ch = ngetchx();
			if (ch >= 0x800) ch -= 0x800;

			if (method == 1) 
			{ if (ch == '*') if (iterations < 128) iterations*=2; 
				if (ch == '/') if (iterations > 2) iterations/=2; 
				if (ch == ')') if (width < 160 -details) width += details +1; 
				if (ch == '(') if (width > details +1) width -= details +1; 
			}
			if (method == 2) 
			{ if (ch == '*') if (iterations < 20) iterations++; 
				if (ch == '/') if (iterations > 2) iterations--; 
				if (ch == ')') if (width < 160 -details*2) width += details*2 +1; 
				if (ch == '(') if (width > details*2 +1) width -= details*2 +1; 
				}
			if (ch == '+') if (details < 15) details = ((details+1)*2)-1; 
			if (ch == '-') if (details > 0) details = ((details+1)/2)-1; 
			
			if (ch == KEY_MODE) if (render_mode < 2) render_mode++; else render_mode=1; 
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_map (long l)
{
	clrscr_gr (1);
	
	FontSetSys (F_6x8);
	if (l == 1)
	{	sprintf (txt, "Generating %f Voxels...", (float) MAP_SIZE*MAP_SIZE);
		srand (825958862); //0 to 2147483647
	}
	else
	{	sprintf (txt, "Map-ID: %f", (float) l);
		srand ((unsigned long) l); //0 to 2147483647
	}
	DrawStr (0, 0, txt, A_NORMAL);

	map_data_p[(0)+(0)*MAP_SIZE] = 128;
  for (i=1, j=0; i<MAP_SIZE; i++)
  {
 		if (i%5 == 0) zs = random(21)-10; else zs = zs *2/3;
 		b = map_data_p[(i-1)+(j)*MAP_SIZE];
  	if (b>10 && b<245) map_data_p[(i)+(j)*MAP_SIZE] = b +zs; else 
  	if (b<=10) map_data_p[(i)+(j)*MAP_SIZE] = b +random(11);	else 
  	if (b>=245) map_data_p[(i)+(j)*MAP_SIZE] = b -random(11);
 
// 		if ((i%8==0) && (j%4==0)) DrawPix (j/2 -i/8 +32, i/4 - map_data_p[(i)+(j)*MAP_SIZE] /8 +32, A_NORMAL);
 	}	
  for (i=0, j=1; j<MAP_SIZE; j++)
  {
 		if (j%5 == 0) zs = random(21)-10; else zs = zs *2/3;
 		b = map_data_p[(i)+(j-1)*MAP_SIZE];
  	if (b>10 && b<245) map_data_p[(i)+(j)*MAP_SIZE] = b +zs; else 
  	if (b<=10) map_data_p[(i)+(j)*MAP_SIZE] = b +random(11);	else 
  	if (b>=245) map_data_p[(i)+(j)*MAP_SIZE] = b -random(11);
  
//		if ((i%8==0) && (j%4==0)) DrawPix (j/2 -i/8 +32, i/4 - map_data_p[(i)+(j)*MAP_SIZE] /8 +32, A_NORMAL);
 	}	

 	for (j=1; j<MAP_SIZE; j++)
 	{
 		for (i=1; i<MAP_SIZE; i++)
  	{
	 		if (i%15 == 1) zs = random(j/75+i/75+2);
 			b =	(map_data_p[(i-1)+(j)*MAP_SIZE] + map_data_p[(i)+(j-1)*MAP_SIZE]) /2;
  		if (b>10 && b<245) map_data_p[(i)+(j)*MAP_SIZE] = b -zs +1; else 
  		if (b<=10) map_data_p[(i)+(j)*MAP_SIZE] = b +random(2);	else 
  		if (b>=245) map_data_p[(i)+(j)*MAP_SIZE] = b -random(2);
 	 
	 		xs = j/2 -i/8 +32;
 		 	ys = i/4 - map_data_p[(i)+(j)*MAP_SIZE] /8 +36;
 			map_buf_fin = map_data_p[(i)+(j)*MAP_SIZE];
 		
 			if ((i%8==1) || (j%4==1))
	 		{
		 		temp_s = random(32);
		 		GraySetAMSPlane (DARK_PLANE);
	 			if (map_buf_fin >= 128-temp_s) DrawPix (xs, ys, A_REVERSE);
				else													 DrawPix (xs, ys, A_NORMAL);
 				GraySetAMSPlane (LIGHT_PLANE);
				if (((map_buf_fin >= 64-temp_s) && (map_buf_fin < 128-temp_s)) ||
						((map_buf_fin >= 192-temp_s) && (map_buf_fin < 256))) DrawPix (xs, ys, A_REVERSE);
				else																					    				DrawPix (xs, ys, A_NORMAL);
	 		} 
		}
	}
 	for (i=1; i<MAP_SIZE; i += 2)
 		for (j=MAP_SIZE-6; j>=1; j -= 1)
  	{
	 		xs = j/2 -i/8 +32;
 		 	ys = i/4 - map_data_p[(i)+(j)*MAP_SIZE] /8 +36;
 			map_buf_fin = map_data_p[(i)+(j)*MAP_SIZE];
 		
 		  map_buf = map_data_p[(i-1)+(j)*MAP_SIZE] -1;
 				
 			FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xs+2, ys, A_NORMAL);
			if ((map_buf_fin >= map_buf) && (map_buf_fin < map_buf+1)) FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xs+2, ys, A_REVERSE);
			if (map_buf_fin >= map_buf) FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xs+2, ys, A_NORMAL);
			if (map_buf_fin < map_buf) FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xs+2, ys, A_REVERSE);
 		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

// Main Function
void _main(void)
{
  map_data_p = (unsigned char *) malloc ((unsigned short) MAP_SIZE*MAP_SIZE+1);

	if (!GrayOn ())
    return;
	MAX_X2 = MAX_X /2; 
	clrscr_gr (0);
	if (!kbhit()) for (w=0; w<500000; w++); //wait
	
	srand(1);

	FontSetSys(F_6x8);
	sprintf (txt, "Kai Kostack"); print_title (45, 45);
	title(); clrscr_gr (0);
	FontSetSys(F_6x8);
	sprintf (txt, "presents"); print_title (55, 45);
	title(); clrscr_gr (0);
	FontSetSys(F_8x10);
	sprintf (txt, "VOXELSPACE");	print_title (35, 45);
	title(); clrscr_gr(0);
	FontSetSys(F_6x8);
	sprintf (txt, "The Technology Demo"); print_title (20, 45);
	title(); clrscr_gr (0);
	GKeyFlush();
							
//****************************************************************************
	generate_map (1);
	ngetchx();

//****************************************************************************
menu:
ch = 1;
while ((ch != KEY_ESC) && (ch != '1') && (ch != '2'))
{
	clrscr_gr (1);

	GraySetAMSPlane (LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{30, 10, 159-10, 99-30}}, &full_screen , A_NORMAL); 
  GraySetAMSPlane (DARK_PLANE);  ScrRectFill (&(SCR_RECT){{10, 30, 159-30, 99-10}}, &full_screen , A_NORMAL); 

	FontSetSys (F_6x8);
	sprintf (txt, "Which method shall"); DrawStr (31, 12, txt, A_NORMAL);
	sprintf (txt, "I use for rendering?"); DrawStr (30, 21, txt, A_NORMAL);
	sprintf (txt, "[1] Z-Plotter"); DrawStr (39, 35, txt, A_REVERSE);
	sprintf (txt, "[2] Raytracer"); DrawStr (39, 47, txt, A_REVERSE);
	FontSetSys (F_4x6);
	sprintf (txt, "or [3] for a new map"); DrawStr (41, 60, txt, A_REVERSE);
	sprintf (txt, "VOXELSPACE - Technology Demo v1.2"); DrawStr (29, 2, txt, A_NORMAL);
	sprintf (txt, "For more 3D CGI visit"); DrawStr (32, 73, txt, A_REVERSE);
	sprintf (txt, "www.KaiKostack.com"); DrawStr (52, 81, txt, A_REVERSE);
	sprintf (txt, "Copyright (C) 2004 by Kai Kostack"); DrawStr (9, 93, txt, A_NORMAL);
	ch = 1;
	while ((ch != KEY_ESC) && (ch != '1') && (ch != '2') && (ch != '3')) ch = ngetchx();
	if (ch == '1') method = 1;
	if (ch == '2') method = 2;
	if (ch == '3')
	{ 
		clrscr_gr (1);
		FontSetSys (F_4x6);
		sprintf (txt, "Enter a previous Map-ID or press [Enter]:", (float) MAP_SIZE*MAP_SIZE);
		DrawStr (9, 40, txt, A_NORMAL);
		FontSetSys (F_6x8);
		MoveTo (15, 50);
		strcpy (txt, "\0");
		gets (txt);
		FontSetSys (F_4x6);
		if (txt[0] != '\0')
		{	l = atol (txt);
			if ((l >= 1) && (l <= 2147483647)) generate_map ((long) l); //0 to 2147483647
			else DrawStr (4, 62, "ERROR! - Not in range from 1 to 2147483647!", A_NORMAL);
		}
		else 
		{	randomize(); generate_map ((float) random(32767) *32767 +random(32767)); }
		ngetchx();
	}
}
if (ch == KEY_ESC) goto quit;

//****************************************************************************
  clrscr_gr (1);

	cam.x = 250 *100;
	cam.y = 150 *100; 	 	  
	cam.z = 30 *100;
  horizon = 33;
	for (ys=66; ys>=0; ys--)
  	for (xs=0; xs<MAX_X; xs++)
  	{
			ray_map[xs+ys*MAX_X].x = -128; 	 	  
			ray_map[xs+ys*MAX_X].y = 2* ((xs - MAX_X2)); 	 	  
			ray_map[xs+ys*MAX_X].z = 2* (4* -(ys - horizon)); 	 	  
		}
	movement.x = 0 -100; movement.y = 0 -100; movement.z = 0 +150;
	
	interlace = 0;
	details = 1;
	width = MAX_X;
	render_mode = 2;

	if (method == 1) iterations = 32; // 32 is good, a higher level shows more details but is slower.
	if (method == 2) iterations = 8; // 8 is good, a higher level shows more details but is slower.

//  OSFastArrows = 2;
	ch = 2;
	while (ch!=KEY_ESC)
	{
		if ((ch == 2) || (ch == ')') || (ch == '(') || (ch == '+') || (ch == '-'))
		{	GraySetAMSPlane (DARK_PLANE);
			ScrRectFill (&(SCR_RECT){{0, 0, MAX_X, 66}}, &full_screen , A_NORMAL); 
			GraySetAMSPlane (LIGHT_PLANE);
			ScrRectFill (&(SCR_RECT){{0, 0, MAX_X, 66}}, &full_screen , A_REVERSE); 
			ch = 1;
		}
  	GraySetAMSPlane (DARK_PLANE);
		ScrRectFill (&(SCR_RECT){{0, 68, 159, 99}}, &full_screen , A_NORMAL); 
		FontSetSys (F_4x6);
		sprintf (txt, "%f %f %f", (float) cam.x, (float) cam.y, (float) cam.z); DrawStr (0, 100-6*5-1, txt, A_REVERSE);
		if (render_mode == 1) sprintf (txt, "[MODE] Voxel shader: Gourad heights"); DrawStr (0, 100-6*4, txt, A_REVERSE);
		if (render_mode == 2) sprintf (txt, "[MODE] Voxel shader: Light mapping"); DrawStr (0, 100-6*4, txt, A_REVERSE);
		sprintf (txt, "[(][)] Picture width: %f ", (float) width ); DrawStr (0, 100-6*3, txt, A_REVERSE);
		sprintf (txt, "[+][-] Pixel increment: %f ", (float) details+1 ); DrawStr (0, 100-6*2, txt, A_REVERSE);
		if (method == 1) sprintf (txt, "[*][/] Depth resolution: %f ", (float) iterations); DrawStr (0, 100-6*1, txt, A_REVERSE);
		if (method == 2) sprintf (txt, "[*][/] Ray division iterations: %f ", (float) iterations); DrawStr (0, 100-6*1, txt, A_REVERSE);

	  cam.x += movement.x; 	 	  
		cam.y += movement.y; 	 	  
		cam.z += movement.z;
		if ((cam.y <= 0 *100) || (cam.y >= 150 *100))
		{ movement.x = -movement.x;	movement.y = -movement.y; movement.z = -movement.z;	}	 	  
	
		xn = cam.x /100;
		yn = cam.y /100;
		zn = cam.z /100;
		horizon = 66- (zn /8 +25);
		
		if (method == 2)
		{
		js = (MAX_X -width) /2;			
		ks = (MAX_X +width) /2 -details;
		ls = 1 +details;
		for (ys=66 -interlace; ys>=0; ys-=2)
		{
			for (xs=js; xs < ks; xs+=ls)
  		{
				ray_map[xs+ys*MAX_X].z = 2* (4* -(ys - horizon)); 	 	  
		
				map_buf_fin = 0;
				x = xn; y = yn; z = zn;
				temp_s = xs+ys*MAX_X;
				x += xr = ray_map[temp_s].x /2;
				y += yr = ray_map[temp_s].y /2;
				z += zr = ray_map[temp_s].z /2;
				for (is=1; (is < iterations); is++)
	 			{
	 				if ((x>=0) && (x<MAP_SIZE) && (y>=0) && (y<MAP_SIZE) && (z>0) && (z<256))
						map_buf = map_data_p[x+y*MAP_SIZE];
		 			else map_buf = 0;
					
					if ((map_buf != 0) && (z > map_buf))
  				{	temp_s = (2*is);
						x += xr /temp_s;
						y += yr /temp_s;
						z += zr /temp_s;
  				}
  				else 	 	  
 					{	xo = x; yo = y;
 						temp_s = (2*is);
						x -= xr /temp_s;
						y -= yr /temp_s;
						z -= zr /temp_s;
						map_buf_fin = map_buf;
					}
 				}
			
				xr = xs + details;
				if (render_mode == 2)
				{
	 				if ((map_buf_fin > 0) && (xo > 0))
					{
 					 	map_buf = map_data_p[(xo-1)+yo*MAP_SIZE] -1;
	 	 		
	 	 				FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_NORMAL);
						if ((map_buf_fin >= map_buf) && (map_buf_fin < map_buf +1)) FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_REVERSE);
	 					
						if (map_buf_fin >= map_buf) FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_NORMAL);
						if (map_buf_fin < map_buf) FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_REVERSE);
					}
					else
					if (ys < horizon)
					{	FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_NORMAL);
					  FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_NORMAL); }
					else
					{	FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_REVERSE);
					  FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_REVERSE);	}
				}
				else
				if (render_mode == 1)
				{
					if (map_buf_fin > 0)
					{
 						srand (map_buf_fin);
						temp_s = random(32);
				 		if (map_buf_fin >= 128-temp_s) FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_REVERSE);
						else													 FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_NORMAL); 
	 					if (((map_buf_fin >= 64-temp_s) && (map_buf_fin < 128-temp_s)) ||
								((map_buf_fin >= 192-temp_s) && (map_buf_fin < 256))) FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_REVERSE);
						else																					    				FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_NORMAL); 
					}
					else
					if (ys < horizon)
					{	FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_NORMAL);
					  FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_NORMAL); }
					else
					{	FastDrawHLine (GrayGetPlane (LIGHT_PLANE), xs, xr, ys, A_REVERSE);
					  FastDrawHLine (GrayGetPlane (DARK_PLANE), xs, xr, ys, A_REVERSE);	}
				}
			}
			check_keys();
		}
		}
		
		if (method == 1)
		{
		js = (MAX_X -width) /2 +interlace;			
		ks = (MAX_X +width) /2 -details *2 +interlace -1;
		ls = 2 +details*2;
		for (xs = js; xs < ks; xs += ls)
 		{
			xsoo = xs +details*2;
			
			ys = 66;
			xr = ray_map[xs].x;
			yr = ray_map[xs].y;
			
			for (is=1; (is <= iterations); is++)
			{
				y = yn + ((long) yr *is) /iterations;
			
				if ((y >= 0) && (y < MAP_SIZE))
				{
					x = xn + ((long) xr *is) /iterations;
				
					if ((x >= 0) && (x < MAP_SIZE))
					{
		 				map_buf_fin = map_data_p[x+y*MAP_SIZE];
	 		
						yso = ys;
						ys = horizon + (((zn -map_buf_fin) *iterations) /is) /8;
	 					
	 					if (ys < yso)
						{
							if (render_mode == 2)
							{
		 					 	map_buf = map_data_p[(x-1)+y*MAP_SIZE] -1;
		 				
								for (xso = xs; xso <= xsoo; xso += 2)
								{
			 						GraySetAMSPlane (LIGHT_PLANE);
									DrawLine (xso, yso, xso, ys, A_NORMAL);
									if ((map_buf_fin >= map_buf) && (map_buf_fin < map_buf +1)) DrawLine (xso, yso, xso, ys, A_REVERSE);
								
									GraySetAMSPlane (DARK_PLANE);
									if (map_buf_fin >= map_buf) DrawLine (xso, yso, xso, ys, A_NORMAL);
									if (map_buf_fin < map_buf) DrawLine (xso, yso, xso, ys, A_REVERSE);
								}			
							}
							else
							if (render_mode == 1)
							{
								srand (map_buf_fin);
								temp_s = random(32);
								
								for (xso = xs; xso <= xsoo; xso += 2)
								{
			 						GraySetAMSPlane (DARK_PLANE);
			 						if (map_buf_fin >= 128-temp_s) DrawLine (xso, yso, xso, ys, A_REVERSE);
									else													 DrawLine (xso, yso, xso, ys, A_NORMAL); 
									GraySetAMSPlane (LIGHT_PLANE);
									if (((map_buf_fin >= 64-temp_s) && (map_buf_fin < 128-temp_s)) ||
											((map_buf_fin >= 192-temp_s) && (map_buf_fin < 256))) DrawLine (xso, yso, xso, ys, A_REVERSE);
									else																					    				DrawLine (xso, yso, xso, ys, A_NORMAL); 
			 					}	
							}
						}
						else
						if (ys < 0) is = iterations; else
						if ((ys > 66) || (ys > yso)) ys = yso;
					}
				}
			}
			if (ys > 0)
			{
				if (ys < horizon)
				for (xso = xs; xso <= xsoo; xso += 2)
				{	GraySetAMSPlane (LIGHT_PLANE);
					DrawLine (xso, 0, xso, ys-1, A_NORMAL);
					GraySetAMSPlane (DARK_PLANE);
					DrawLine (xso, 0, xso, ys-1, A_NORMAL); }
				else
				for (xso = xs; xso <= xsoo; xso += 2)
				{	GraySetAMSPlane (LIGHT_PLANE);
					DrawLine (xso, 0, xso, horizon-1, A_NORMAL);
					DrawLine (xso, horizon, xso, ys, A_REVERSE);
					GraySetAMSPlane (DARK_PLANE);
					DrawLine (xso, 0, xso, horizon-1, A_NORMAL); 
					DrawLine (xso, horizon, xso, ys, A_REVERSE); }
			}
		}
		check_keys();
		}
	
		if (interlace < 1) interlace++; else interlace = 0;
	}
	clrscr_gr (1);
 	goto menu;
 
 	quit:
  free (map_data_p);
  GrayOff ();
}
